/*
 * JBoss, Home of Professional Open Source.
 * Copyright 2024 Red Hat, Inc., and individual contributors
 * as indicated by the @author tags.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jboss.installer.postinstall.task.utils;

import java.util.List;

import org.jboss.dmr.ModelNode;

public class ModelUtils {

    public static ModelNode createEmptyOperation(String name, ModelNode address) {
        final ModelNode op = new ModelNode();
        op.get("operation").set(name);
        op.get("address").set(address);
        return op;
    }

    public static ModelNode createEmptyOperation(String name) {
        return createEmptyOperation(name, createEmptyAddress());
    }

    public static ModelNode createEmptyAddress() {
        return new ModelNode().setEmptyList();
    }

    public static ModelNode prependToOperationAddress(ModelNode op, String key, String value) {
        ModelNode newOp = op.clone();
        final List<ModelNode> oldAddress = op.get("address").asList();

        ModelNode profileAddress = new ModelNode().setEmptyList();
        profileAddress.add(key, value);
        oldAddress.forEach(node->profileAddress.add(node.asProperty().getName(), node.asProperty().getValue()));

        newOp.get("address").set(profileAddress);
        return newOp;
    }

    public static ModelNode pathAddress(String key, String value) {
        return createEmptyAddress().add(key, value);
    }
}
